diff -c -N -r vtun-2.6/README.Crypto vtun-3.0-RvR/README.Crypto
*** vtun-2.6/README.Crypto	Thu Jan  1 01:00:00 1970
--- vtun-3.0-RvR/README.Crypto	Fri Oct 10 13:50:04 2003
***************
*** 0 ****
--- 1,227 ----
+ -----BEGIN PGP SIGNED MESSAGE-----
+ Hash: SHA1
+ 
+ CRYPTOGRAPHIC AUDIT RESULTS FOR VTUN-2.6
+ 
+     OpenFortress has been looking into the option of extending VTun with
+     code for hardware tokens to conceal the symmetric secrets and provide
+     an industry-strength VPN where the only cost would be for the tokens.
+     In the course of this investigation we discovered several flaws in the
+     security of VTun up to version 2.6.  We repaired them and donated the
+     results back to the VTun project as a proposed 3.0 version.
+ 
+     Rick van Rein <rick@openfortress.nl>
+ 
+ 
+ >> Quick overview
+ 
+ To parties who do not rely on encryption or authentication, there is no direct
+ reason to stop using version 2.6 of VTun.
+ 
+ The versions of VTun starting with 3.0 are NOT BACKWARDS COMPATIBLE with
+ versions up to 2.6; the cryptgraphic improvements involved revising the
+ challenge/response authentication mechanism, and providing a backward
+ compatible option would have meant re-introducing the old security problems.
+ As a result, you must update communicating VTun systems all at the same time.
+ The configuration files are backward compatible, so the upgrade only involves
+ the software version.
+ 
+ The reported security problems included the ability to inject any desired
+ packet into the encrypted streams.  One hole allows this to users who send
+ data trough the tunnel, another allows this to intermediate parties who
+ manage to direct client traffic to their computer.  In addition to this
+ abililty to send any encrypted data, we were not convinced of the inability
+ to decrypt traffic.  Finally, authentication was not implemented properly.
+ 
+ 
+ >> Symmetric encryption... and authentication
+ 
+ There is no real problem in using symmetric encryption between two parties,
+ the only disadvantage is that the encryption schema as a whole is only as
+ strong as the weakest secret-keeping.  If multiple tunnels are used
+ simultaneously, the breaking of one could help to break the others as
+ well.  This was why we looked into the use of relatively low-cost tokens (the
+ ePass1000, see vpn.epass.nl for info).  Concealing the secrets within a
+ cryptographic token at both sides of a tunnel, and never leaving those secrets
+ out, would make a good way of protecting the connection -- since both the
+ physical token and its PIN are needed to play the role of an endpoint of the
+ tunnel.
+ 
+ On the other hand, using symmetric encryption for authentication is generally
+ considered bad practice, certainly if this uses the same password for normal
+ encryption and authentication-by-encryption.  The 2.6 version of VTun was in
+ conflict with this secure coding guideline. The use of secure hash functions
+ can easily improve security, since it disables reverse calculations that might
+ abuse or derive secrets.
+ 
+ In more detail, authentication on VTun up to 2.6 was done with a challenge (a
+ randomly chosen bitstring from the server) that had to be encrypted with the
+ password and sent back to the server for authentication.  This is where it goes
+ wrong: any party who manages to impersonate the server using non-cryptographic
+ attacks could challenge the client over and over again with challenges that are
+ actually packages that the attacker wanted to see encrypted.  In this setup,
+ the client plays the role of a signing party.  In other words, there was no
+ need to obtain the password to fool VTun into believing it was possessed.
+ 
+ Starting with version 3.0, VTun employs HMAC-MD5 to make authenticating
+ calculations.  This is done using the password, but the password is scrambled
+ heavily before being used as an encryption key.  HMAC-MD5 incorporates both
+ the password and a challenge received from the other side.  The response sent
+ back after a challenge is actually the SHA1 of the HMAC-MD5 calculation,
+ because the HMAC-MD5 outcome is used to obtain the encryption key.  Note that
+ this key material cannot be derived from the SHA1 result.
+ 
+ The results which came out of HMAC-MD5 but which never travelled over the wire
+ (because it was their SHA1 secure hash that travelled) are concatenated (server
+ first) and hashed through SHA1 (in a different manner than for the wired data)
+ to construct the session key.  This session key is influenced by both parties
+ in the communication, and none is able to set the session key to anything of
+ their own desire (which could have opened a hole to attackers).
+ 
+ Up to version 2.6, VTun only did authentication in one direction only.  The
+ server was implicitly trusted (in a world full of spoofing options, notably in
+ DNS, ARP and DHCP) and only the client's authenticity was verified (which is
+ needed indeed, unless you assume that the ability to send encrypted message
+ suffices as a proof of authenticity).  Starting version 3.0, VTun authenticates
+ in both directions.  The implementation of bi-directional authentication would
+ not have added much under the old authentication mechanism, since that was a
+ symmetric mechanism.  With the new authentication mechanism in place, there is
+ a meaningful added value in bi-directional authentication.
+ 
+ 
+ >> Encryption mode
+ 
+ The encryption algorithm used in VTun is Blowfish, a popular block cipher
+ that works in blocks of 8 bytes at once.  It can provide acceptable encryption,
+ if used well.  Vtun up to version 2.6 did not use it well.
+ 
+ When block ciphers are employed, it is important to incorporate the environment
+ of the block being encoded into the encoding process.  If this is not done,
+ each block can be individually copied and pasted to another block-aligned
+ location.  And because users behind a tunnel can easily send any desired data
+ over the tunnel, the construction of encrypted versions of data-to-be-sent is
+ not hard.  And as specified above, it is not even impossible for an external
+ attacker to trick a VTun daemon up to version 2.6 into encrypting anything
+ desired.  Influence by context would have gravely complicated such scenario's.
+ Blowfish was used in the so-called ECB mode, instead of in a much more secure
+ mode, like CBC.
+ 
+ Starting with 3.0, Blowfish is used in CBC mode, where the encryption output
+ of a previous block is taken into account in the next block.  A problem is
+ the start of such a block sequence; with TCP connections that would work,
+ but if VTun works over UDP (with out-of-order delivery possible) there is a
+ need to reset the encryption schedule for every packet sent.  To solve this,
+ the padding before the block is filled with pseudo-random data, at least
+ one block in size.  This is especially useful because network packets tend to
+ start with highly predictable headers.  Since there prefiexed block causes good
+ variation in the beginning of each network packet before encryption starts, it
+ is not possible to recognise patterns in this traffic anymore.
+ 
+ In the near future, we hope to employ AES as the encryption mechanism, probably
+ in counter mode.  It uses longer blocks, making it more secure than Blowfish
+ can be.  The reason for still supporting Blowfish (and only Blowfish) in the
+ current version is that this is currently unsupported in the underlying
+ crypto-library used by VTun.  Writing such mechanisms would have been possible,
+ but it would have placed serious restrictions on the ability to distribute VTun
+ accross certain country borders.
+ 
+ 
+ >> Vulnerability of passwords
+ 
+ Although somewhat secure, it is not ideal that VTun had to mention all its
+ tunnel-encrypting passwords in files.  It is even less pleasant that passwords
+ for all tunnels are combined in one file, at least for a server on a particular
+ port.  Firstly, because an administrator with access to one password would also
+ have access other passwords.  In addition to this, the direct use of passwords
+ made it possible that a code could be stolen and used to tap the network.
+ 
+ A practical defense against tapping a network flow is to change the session key
+ regularly.  Only when the flow was followed from the beginning, and only when
+ the initial password was known, could such a stream be decrypted.  Starting
+ with VTun 3.0, there is a session key in place.  And although this key is not
+ automatically renegotiated, it will be different every time the connection is
+ re-established.  Regularly restarting a VTun connection from either side would
+ suffice to arrange this.
+ 
+ An even better scheme to avoid misuse of the password is to conceal it in the
+ encasing of a cryptographic piece of hardware, commonly known as a token.  This
+ need not be the most complicated token around, a symmetric HMAC functionality
+ based on internally stored password will do.  An example of such a token is the
+ ePass1000 and starting with VTun 3.0 there is code in place to support this
+ token.  Furthermore, the website vpn.epass.nl has been set up in support of
+ this application.
+ 
+ This must be explicitly configured with the following option,
+ 	./configure --enable-epass
+ because the include files from the ePass1000 software must be present on the
+ system.  The driver software will be loaded dynamically by the software, so it
+ is possible to build such a binary with ePass support enabled, and distribute
+ it to people with or without such a token.
+ 
+ To load the drivers on systems equipped with them, the configuration file
+ must declare an option
+ 	cryptoken "epass1000";
+ If this is done, there must not be a password entry in the configuration file,
+ but instead there may be a keydir and there must be a keynum:
+ 	keydir "OpenFortress_tunnel_epass";
+ 	keynum 123456;
+ The keynum links to (a) key file(s) residing on the filesystem of the card, in
+ this case under a directory OpenFortress_tunnel_epass.  They are assumed to
+ provide the hardware with the details to perform a HMAC-MD5 calculation in such
+ a way that the involved secret remains on the token.
+ 
+ 
+ >> Impact on Efficiency
+ 
+ The impact on VTun efficiency by all the foregoing is negligable.  The
+ increased length of the network packets (8 bytes more than in 2.6) is the only
+ new overhead while a connection is up and running.  The rest only comes to play
+ during authentication, that is, during the initiation of a connection.  This is
+ a rare event, and since the client usually backs off for a matter of seconds
+ before attempting to reconnect, the impact is again negligable.  This is even
+ the case when a (relatively slow) communication with an ePass or other token is
+ required.
+ 
+ It is our hope to see the change to encryption with AES in counter mode
+ sometime soon.  If this happens, it will be possible to pre-calculate and
+ buffer encryption patterns, even before data is being received to be encrypted
+ or decrypted.  This would make it possible to realise a tunnel with a minimal
+ transmission delay.
+ 
+ 
+ >> Conclusion
+ 
+ It is as Bruce Schneier stated, cryptography is a black art; if not applied
+ properly it can backfire.  It is obvious that encryption and authentication
+ in VTun 2.6 are subject to such backfiring, in spite of the high quality of the
+ remainder of the software.
+ 
+ OpenFortress is pleased to have helped to improve this popular piece of
+ software, and hopes to have constructed a greatly improved, hopefully even
+ uncrackable, cryptographic application.
+ 
+ Please think of us when your company relies on the cryptographic qualities
+ of open source software -- we are here to help you investigate its problems,
+ and come up with solutions if so required.
+ 
+ 
+ Sincerely,
+ 
+ Rick van Rein,
+ Cryptographic Auditor,
+ OpenFortress Digital signatures
+ 
+ http://openfortress.nl/service/audit/
+ 
+ The key signing this audit is available for rick@openfortress.nl on
+ http://openfortress.nl/cgi-bin/pgplookup.cgi
+ 
+ 
+ -----BEGIN PGP SIGNATURE-----
+ Version: GnuPG v1.0.6 (FreeBSD)
+ Comment: To understand digital signatures visit http://openfortress.nl
+ 
+ iD8DBQE/hpziFBGpwol1RgYRArEKAKCSmj7hVIvDSZUQ3DkQCV1R+IqiKQCeISGc
+ 5DznUe/GZutMoLUfjbAitE0=
+ =w6S+
+ -----END PGP SIGNATURE-----
diff -c -N -r vtun-2.6/auth.c vtun-3.0-RvR/auth.c
*** vtun-2.6/auth.c	Mon Dec 16 22:40:44 2002
--- vtun-3.0-RvR/auth.c	Fri Oct 10 14:16:41 2003
***************
*** 58,129 ****
  #include "lock.h"
  #include "auth.h"
  
  /* Encryption and Decryption of the challenge key */
- #ifdef HAVE_SSL
  
  #ifndef __APPLE_CC__
  #include <openssl/md5.h>
  #include <openssl/blowfish.h>
  #include <openssl/rand.h>
  #else /* YAY - We're MAC OS */
  #include <sys/md5.h>
  #include <crypto/blowfish.h>
  #endif  /* __APPLE_CC__ */
  
  void gen_chal(char *buf)
  {
!    RAND_bytes(buf, VTUN_CHAL_SIZE);
  }
  
! void encrypt_chal(char *chal, char *pwd)
! { 
!    register int i;
!    BF_KEY key;
! 
!    BF_set_key(&key, 16, MD5(pwd,strlen(pwd),NULL));
  
!    for(i=0; i < VTUN_CHAL_SIZE; i += 8 )
!       BF_ecb_encrypt(chal + i,  chal + i, &key, BF_ENCRYPT);
  }
  
! void decrypt_chal(char *chal, char *pwd)
! { 
!    register int i;
!    BF_KEY key;
  
!    BF_set_key(&key, 16, MD5(pwd,strlen(pwd),NULL));
  
!    for(i=0; i < VTUN_CHAL_SIZE; i += 8 )
!       BF_ecb_encrypt(chal + i,  chal + i, &key, BF_DECRYPT);
  }
  
! #else /* HAVE_SSL */
  
! void encrypt_chal(char *chal, char *pwd)
! { 
!    char * xor_msk = pwd;
!    register int i, xor_len = strlen(xor_msk);
  
!    for(i=0; i < VTUN_CHAL_SIZE; i++)
!       chal[i] ^= xor_msk[i%xor_len];
  }
  
! void inline decrypt_chal(char *chal, char *pwd)
! { 
!    encrypt_chal(chal, pwd);
  }
  
! /* Generate PSEUDO random challenge key. */
! void gen_chal(char *buf)
! {
!    register int i;
!  
!    srand(time(NULL));
  
!    for(i=0; i < VTUN_CHAL_SIZE; i++)
!       buf[i] = (unsigned int)(255.0 * rand()/RAND_MAX);
  }
- #endif /* HAVE_SSL */
  
  /* 
   * Functions to convert binary flags to character string.
--- 58,336 ----
  #include "lock.h"
  #include "auth.h"
  
+ #ifdef USE_EPASS
+ #include <epass/epassapi.h>
+ static EPAS_HANDLE ePass;
+ #endif
+ 
+ 
  /* Encryption and Decryption of the challenge key */
  
  #ifndef __APPLE_CC__
  #include <openssl/md5.h>
+ #include <openssl/hmac.h>
  #include <openssl/blowfish.h>
  #include <openssl/rand.h>
  #else /* YAY - We're MAC OS */
  #include <sys/md5.h>
+ #include <crypto/hmac.h>
  #include <crypto/blowfish.h>
  #endif  /* __APPLE_CC__ */
  
  void gen_chal(char *buf)
  {
!    if ((!vtun.epasslib) || rndgen_cryptoken (buf, VTUN_CHAL_SIZE)) { 
!       RAND_bytes (buf, VTUN_CHAL_SIZE);
!    }
  }
  
! #ifdef USE_EPASS
  
! /* Routines to open and close the ePass1000 device.
!  * These are also called before vtun forks, to ask/send the PIN for
!  * access if needed.  If the PIN had not been entered before, this would
!  * cause problems with the detached tty.
!  * These routines return 0 for okay or -1 for error; in the latter
!  * case, errno has been set to indicate the type of error.
!  */
! 
! /* Translate a token-specific error message into a generic Unix message.
!  * This routine returns 0 for FT_SUCCESS, or sets errno and returns -1.
!  */
! static int errormap_cryptoken (int fterr) {
!    switch (fterr) {
!    case FT_SUCCESS:
! 	return 0;
!    case FT_PIN_EXPIRED:
! 	errno = EPERM;
! 	return -1;
!    case FT_ACCESS_DENIED:
! 	errno = EACCES;
! 	return -1;
!    case FT_CANNOT_OPEN_DRIVER:
!    case FT_INVALID_DRVR_VERSION:
!    case FT_DEVICE_REMOVED:
! 	errno = ENODEV;
!    	return -1;
!    case FT_UNIT_NOT_FOUND:
! 	errno = ENXIO;
! 	return -1;
!    case FT_COMMUNICATIONS_ERROR:
!    case FT_MEM_CORRUPT:
!    case FT_INTERNAL_HW_ERROR:
!    case FT_INVALID_STATUS:
! 	errno = EIO;
! 	return -1;
!    case FT_DIR_NOT_FOUND:
!    case FT_FILE_NOT_FOUND:
!    case FT_ITEM_NOT_FOUND:
! 	errno = ENOENT;
! 	return -1;
!    case FT_ALREADY_EXISTS:
! 	errno = EEXIST;
! 	return -1;
!    case FT_NOT_ENOUGH_MEMORY:
! 	errno = ENOMEM;
! 	return -1;
!    case FT_INVALID_FILE_SELECTED:
! 	errno = ENOEXEC;
! 	return -1;
!    case FT_TIME_OUT_ERROR:
! 	errno = ETIMEDOUT;
! 	return -1;
!    case FT_INPUT_TOO_LONG:
! 	errno = EMSGSIZE;
! 	return -1;
!    case FT_COMMAND_ABORTED:
! 	errno = EINTR;
! 	return -1;
!    case FT_INVALID_COMMAND:
!    case FT_INVALID_RESP_SIZE:
!    case FT_INVALID_PARAMETER:
!    default:
! 	errno = EINVAL;
! 	return -1;
!    }
!    return 0;
  }
  
! /* Open the connection to the ePass.
!  * There may only be one application using it at a time, so it is important
!  * to open/use/close quickly.
!  */
! int open_cryptoken (void) {
!    int myerr = 0;
!    int state = 0;
!    int tries = 3;
!    char chal [VTUN_CHAL_SIZE];
!    char resp [VTUN_RESP_SIZE];
! 
!    if (!vtun.epasslib) {
! 	   errno = ENODEV;
! 	   return -1;
!    }
! 
!    /* Create handler structure for the ePass1000 driver */
!    if (!myerr)
!    if (errormap_cryptoken (epas_CreateContext (&ePass, 0, EPAS_API_VERSION))) {
! 	   myerr++;
!    } else {
! 	   state++;
!    }
! 
!    /* Connect with the ePass1000 device... if it is present in a slot! */
!    if (!myerr)
!    if (errormap_cryptoken (epas_OpenDevice (ePass, EPAS_OPEN_FIRST, NULL))) {
! 	   myerr++;
!    } else {
! 	   state++;
!    }
! 
!    epas_SetProperty (ePass, EPAS_PROP_LED_OFF, NULL, NULL, 0);
! 
!    /* Cleanup in case of error */
!    if (myerr) {
! 	   epas_SetProperty (ePass, EPAS_PROP_LED_ON, NULL, NULL, 0);
! 	   if (state >= 2) {
! 		   epas_CloseDevice (ePass);
! 	   }
! 	   if (state >= 1) {
! 		   epas_DeleteContext (ePass);
! 	   }
!    }
  
!    /* Return the proper error values */
!    if (myerr) {
! 	   return -1;
!    } else {
! 	   return 0;
!    }
! }
! 
! /* Close the ePass crypto-token.  Important to free to card for others.
!  */
! int close_cryptoken (void) {
!    epas_SetProperty (ePass, EPAS_PROP_LED_ON, NULL, NULL, 0);
!    epas_CloseDevice (ePass);
!    epas_DeleteContext (ePass);
!    return 0;
! }
  
! /* Generate random bytes on the ePass and return them in the given buffer.
!  */
! int rndgen_cryptoken (char *buf, int size) {
!    return errormap_cryptoken (epas_GenRandom (ePass, 0, buf, VTUN_CHAL_SIZE));
  }
  
! /* Perform a challenge/response exchange on the ePass.  The ePass must be open.
!  */
! int challenge_cryptoken (char *keydir, unsigned long keynum, char chal[VTUN_CHAL_SIZE], char resp[VTUN_RESP_SIZE]) {
!    int retval = 0;
!    unsigned long key1 = keynum >> 16;
!    unsigned long key2 = keynum & 0x0000ffffL;
! 
!    epas_SetProperty (ePass, EPAS_PROP_LED_ON, NULL, NULL, 0);  /* Flicker */
! 
!    /* Check if the expected application exists on this device */
!    if (keydir == NULL) {
! 	keydir = "OpenFortress_tunnel_epass";
!    }
!    retval = errormap_cryptoken (epas_ChangeDir (ePass, EPAS_DIR_BY_NAME, 0, keydir));
! 
!    /* Obtain the signature based on key numbers */
!    if (retval == 0)
!    retval = errormap_cryptoken (epas_MD5_HMAC (ePass, key1, key2, chal, VTUN_CHAL_SIZE, resp));
  
!    epas_SetProperty (ePass, EPAS_PROP_LED_OFF, NULL, NULL, 0); /* Flicker */
  
!    return retval;
  }
  
! /* Login to the ePass by sending it its PIN.  The ePass must be open.
!  * NOTE: Currently not used, login is assumed to be done externally.
!  */
! int login_cryptoken (char *pin) {
!    return errormap_cryptoken (epas_Verify (ePass, EPAS_VERIFY_USER_PIN, pin, strlen (pin)));
  }
  
! #else
  
! /* Placeholder functions to represent the lack of a cryptographic token.
!  * Would this ideally be arranged dynamically or statically?
!  */
! int open_cryptoken (void) {
! 	errno = -ENODEV;
! 	return -1;
! }
! int close_cryptoken (void) {
! 	errno = -ENODEV;
! 	return -1;
! }
! int rndgen_cryptoken (char *buf, int size) {
! 	errno = -ENODEV;
! 	return -1;
! }
! int challenge_cryptoken (char *keydir, unsigned long keynum, char chal[VTUN_CHAL_SIZE], char resp[VTUN_RESP_SIZE]) {
! 	errno = -ENODEV;
! 	return -1;
! }
! int login_cryptoken (char *pin) {
! 	errno = -ENODEV;
! 	return -1;
! }
! 
! #endif
! 
! /* Calculate a response to the challenge, using HMAC_MD5 which is also
!  * found in many hardware tokens.  The result goes to 16 bytes at resp
!  * if it is non-NULL.  The MD5 hash of the result goes into the 20 bytes
!  * at resp_h if that is non-NULL.
!  * Even if MD5 is not 100% reliable nowadays, then still the SHA1 provides
!  * excellent protection.  Also, 128 bit passwords are strong enough, even
!  * if MD5 would ever be cracked.
!  * The idea is to use "resp" to form a session key, and send resp_h over
!  * the wire as proof.  This way, the session key is protected with a strong
!  * SHA1 hash, which is quite good.
!  */
! void response_to_chal (char *chal, struct vtun_host *h, char *resp, char *resp_h) {
!    unsigned int mdlen = 16;
!    char response [16];
!    char *cl2cs(char *chal, int bytes);
!    static int nopasspause = 60;
! 
!    if (resp == NULL) {
!       resp = response;
!    }
! 
!    if (vtun.epasslib == NULL) {
!       HMAC (EVP_md5 (), h->passwd, strlen (h->passwd), chal, VTUN_CHAL_SIZE, resp, &mdlen);
!    } else {
!    
!       if (!open_cryptoken ()) {
!           memset (resp, 0, VTUN_RESP_SIZE);
!           if (!challenge_cryptoken (h->keydir, h->keynum, chal, resp)) {
!    	   nopasspause = 60;
!           } else {
!    	   syslog (LOG_ERR, "The ePass reported an error: %m");
!    	   // Most likely cause is that the cryptoken was taken out
!    	   // We have no TTY anymore, so await PIN entrance elsewhere...
!    	   sleep (nopasspause);
!    	   nopasspause <<= 1;
!    	   if (nopasspause > 900) {
!    		   nopasspause = 900;
!    	   }
!           }
!           close_cryptoken ();
!       } else {
!    	syslog (LOG_ERR, "Failed to open ePass: %m");
!       }
! 
!    }
! 
!    if (resp_h != NULL) {
!       SHA1 (resp, 16, resp_h);
!    }
  }
  
  /* 
   * Functions to convert binary flags to character string.
***************
*** 260,273 ****
   * string format:  <char_data> 
   */ 
  
! char *cl2cs(char *chal)
  {
!      static char str[VTUN_CHAL_SIZE*2+3], *chr="abcdefghijklmnop";
       register char *ptr = str;
       register int i;
  
       *(ptr++) = '<';
!      for(i=0; i<VTUN_CHAL_SIZE; i++){
  	*(ptr++) = chr[ ((chal[i] & 0xf0) >> 4) ];  
  	*(ptr++) = chr[ (chal[i] & 0x0f) ];
       }  
--- 467,480 ----
   * string format:  <char_data> 
   */ 
  
! char *cl2cs(char *chal, int bytes)
  {
!      static char str[VTUN_CHALRESP_MAXSIZE*2+3], *chr="abcdefghijklmnop";
       register char *ptr = str;
       register int i;
  
       *(ptr++) = '<';
!      for(i=0; i<bytes; i++){
  	*(ptr++) = chr[ ((chal[i] & 0xf0) >> 4) ];  
  	*(ptr++) = chr[ (chal[i] & 0x0f) ];
       }  
***************
*** 278,284 ****
       return str;
  }
  
! int cs2cl(char *str, char *chal)
  {
       register char *ptr = str;
       register int i;
--- 485,491 ----
       return str;
  }
  
! int cs2cl(char *str, char *chal, int bytes)
  {
       register char *ptr = str;
       register int i;
***************
*** 286,295 ****
       if( !(ptr = strchr(str,'<')) ) 
          return 0;
       ptr++;
!      if( !strtok(ptr,">") || strlen(ptr) != VTUN_CHAL_SIZE*2 )
          return 0;
  
!      for(i=0; i<VTUN_CHAL_SIZE && *ptr; i++, ptr+=2) {
  	chal[i]  = (*ptr - 'a') << 4;  
  	chal[i] |= *(ptr+1) - 'a';
       }
--- 493,502 ----
       if( !(ptr = strchr(str,'<')) ) 
          return 0;
       ptr++;
!      if( !strtok(ptr,">") || strlen(ptr) != bytes*2 )
          return 0;
  
!      for(i=0; i<bytes && *ptr; i++, ptr+=2) {
  	chal[i]  = (*ptr - 'a') << 4;  
  	chal[i] |= *(ptr+1) - 'a';
       }
***************
*** 297,313 ****
       return 1;
  }   
  
  /* Authentication (Server side) */
  struct vtun_host * auth_server(int fd)
  {
!         char chal_req[VTUN_CHAL_SIZE], chal_res[VTUN_CHAL_SIZE];	
  	char buf[VTUN_MESG_SIZE], *str1, *str2;
          struct vtun_host *h = NULL;
  	char *host = NULL;
  	int  stage;
  
          set_title("authentication");
  
  	print_p(fd,"VTUN server ver %s\n",VTUN_VER);
  
  	stage = ST_HOST;
--- 504,558 ----
       return 1;
  }   
  
+ /* Security improvements by Rick van Rein <rick@openfortress.nl>
+  *
+  * Past versions of vtun only challenged the client, but did not establish
+  * that the server was the Proper Party to talk to.  Servers are often
+  * looked up in DNS, which is all too easy to spoof or poison.  Therefore
+  * it is just as important to authenticate the server as it is to authenticate
+  * the client.  (That is, if you assume that the encryption is insufficient
+  * to authenticate the client, then it is also insufficient to authenticate
+  * the server.)
+  *
+  * The server now sends a CHALCLI message instead of CHAL, which will be
+  * properly rejected by older clients.  The client then sends a CHALSRV and
+  * receives the response in a RESPSRV message; only then will it send out
+  * its own RESPSRV message.
+  *
+  * The challenge/response used to be done with BlowFish, which is not quite
+  * suitable for that; one-way functions are much better at it, and certainly
+  * HMAC algorithms.  We choose HMAC_MD5 to allow simple integration with
+  * cheap symmetric crypto-tokens which can be used to securely encapsulate
+  * the secret password.
+  *
+  * The response is not the HMAC_MD5 itself, but a secure hash of this value,
+  * so that the HMAC_MD5, which varies as wildly as the challenge, can be
+  * used for another purpose.  The HMAC_MD5 outcomes for both sides are
+  * concatenated to form a session key.  Killing a tunnel (at night) therefore
+  * suffices to construct a brand new session key.  By using SHA1 to hash the
+  * HMAC_MD5 algorithm, any dependencies of MD5 security alone were avoided.
+  * Even if MD5 is ever broken, it stands to question if HMAC_MD5 will be
+  * broken, and even if that happens then it is still suitable for the current
+  * applications because the outcome of the HMAC_MD5 are only available locally
+  * in the tunnel endpoints.
+  */
+ 
  /* Authentication (Server side) */
  struct vtun_host * auth_server(int fd)
  {
!         char chalcli[VTUN_CHAL_SIZE], chalsrv[VTUN_CHAL_SIZE];
! 	char chal_res[VTUN_RESP_SIZE];
! 	char chal_resh[VTUN_RESP_HASH_SIZE], chal_ansh[VTUN_RESP_HASH_SIZE];
  	char buf[VTUN_MESG_SIZE], *str1, *str2;
          struct vtun_host *h = NULL;
  	char *host = NULL;
  	int  stage;
+ 	SHA_CTX sesctx;
  
          set_title("authentication");
  
+ 	SHA1_Init (&sesctx);
+ 
  	print_p(fd,"VTUN server ver %s\n",VTUN_VER);
  
  	stage = ST_HOST;
***************
*** 326,349 ****
  	        if( !strcmp(str1,"HOST") ){
  		   host = strdup(str2);
  
! 		   gen_chal(chal_req);
! 		   print_p(fd,"OK CHAL: %s\n", cl2cs(chal_req));
  
! 		   stage = ST_CHAL;
  		   continue;
  	        }
  		break;
! 	     case ST_CHAL:
! 	        if( !strcmp(str1,"CHAL") ){
! 		   if( !cs2cl(str2,chal_res) )
! 		      break; 
  		   
  		   if( !(h = find_host(host)) )
  		      break;
  
! 		   decrypt_chal(chal_res, h->passwd);   		
! 	
! 		   if( !memcmp(chal_req, chal_res, VTUN_CHAL_SIZE) ){
  		      /* Auth successeful. */
  
  		      /* Lock host */	
--- 571,610 ----
  	        if( !strcmp(str1,"HOST") ){
  		   host = strdup(str2);
  
! 		   gen_chal(chalcli);
! 		   print_p(fd,"OK CHALCLI: %s\n", cl2cs(chalcli,VTUN_CHAL_SIZE));
  
! 		   stage = ST_CHAL_SRV; // First handle the server challenge
  		   continue;
  	        }
  		break;
! 
! 	     case ST_CHAL_SRV:
! 		if (!strcmp (str1, "CHALSRV")) {
! 		   if (!cs2cl (str2, chalsrv, VTUN_CHAL_SIZE))
! 		      break;
  		   
  		   if( !(h = find_host(host)) )
  		      break;
  
! 		   response_to_chal (chalsrv, h, chal_res, chal_resh);
! 
! 		   print_p (fd, "OK RESPSRV: %s %s\n", cl2cs (chal_resh, VTUN_RESP_HASH_SIZE));
! 		   stage = ST_CHAL_CLI;
! 		   continue;
! 		}
! 		break;
! 
! 	     case ST_CHAL_CLI:
! 	        if( !strcmp(str1,"RESPCLI") ){
! 		   if( !cs2cl(str2,chal_ansh,VTUN_RESP_HASH_SIZE) )
! 		      break; 
! 		   
! 		   SHA1_Update (&sesctx, chal_res, VTUN_RESP_SIZE);  // srv.rnd
! 		   response_to_chal (chalcli, h, chal_res, chal_resh);
! 		   SHA1_Update (&sesctx, chal_res, VTUN_RESP_SIZE);  // cli.rnd
! 
! 		   if( !memcmp(chal_resh, chal_ansh, VTUN_RESP_HASH_SIZE) ){
  		      /* Auth successeful. */
  
  		      /* Lock host */	
***************
*** 353,358 ****
--- 614,621 ----
  		         break;
  		      }	
  		      print_p(fd,"OK FLAGS: %s\n", bf2cf(h)); 
+ 		      SHA1_Final (h->seskey, &sesctx);
+ 		      SHA1_Init (&sesctx);  // wipe data
   		   } else
  		      h = NULL;
  	        }
***************
*** 373,408 ****
  /* Authentication (Client side) */
  int auth_client(int fd, struct vtun_host *host)
  {
! 	char buf[VTUN_MESG_SIZE], chal[VTUN_CHAL_SIZE];
  	int stage, success=0 ;
  	
  	stage = ST_INIT;
  
  	while( readn_t(fd, buf, VTUN_MESG_SIZE, vtun.timeout) > 0 ){
  	   buf[sizeof(buf)-1]='\0';
  	   switch( stage ){
  		case ST_INIT:
  	    	   if( !strncmp(buf,"VTUN",4) ){
- 		      stage = ST_HOST;
  		      print_p(fd,"HOST: %s\n",host->host);
  		      continue;
  	           }
  		   break;	
  
  	        case ST_HOST:
! 		   if( !strncmp(buf,"OK",2) && cs2cl(buf,chal)){
! 		      stage = ST_CHAL;
! 					
! 		      encrypt_chal(chal,host->passwd);
! 		      print_p(fd,"CHAL: %s\n", cl2cs(chal));
  
  		      continue;
  	   	   }
  		   break;	
  	
! 	        case ST_CHAL:
! 		   if( !strncmp(buf,"OK",2) && cf2bf(buf,host) )
  		      success = 1;
  		   break;
  	   }
  	   break;
--- 636,694 ----
  /* Authentication (Client side) */
  int auth_client(int fd, struct vtun_host *host)
  {
! 	char buf[VTUN_MESG_SIZE], chalcli[VTUN_CHAL_SIZE], chalsrv[VTUN_CHAL_SIZE];
! 	char res[VTUN_RESP_SIZE], resh[VTUN_RESP_HASH_SIZE], reshsrv [VTUN_RESP_HASH_SIZE];
  	int stage, success=0 ;
+ 	SHA_CTX sesctx;
  	
  	stage = ST_INIT;
+ 	SHA1_Init (&sesctx);
  
  	while( readn_t(fd, buf, VTUN_MESG_SIZE, vtun.timeout) > 0 ){
  	   buf[sizeof(buf)-1]='\0';
  	   switch( stage ){
  		case ST_INIT:
  	    	   if( !strncmp(buf,"VTUN",4) ){
  		      print_p(fd,"HOST: %s\n",host->host);
+ 		      stage = ST_HOST;
  		      continue;
  	           }
  		   break;	
  
  	        case ST_HOST:
! 		   if( !strncmp(buf,"OK CHALCLI",10) && cs2cl(buf,chalcli,VTUN_CHAL_SIZE)){
! 		      gen_chal(chalsrv);
! 		      print_p (fd, "CHALSRV: %s\n", cl2cs (chalsrv, VTUN_CHAL_SIZE));
! 		      stage = ST_CHAL_SRV;
! 		      continue;
! 		   }
! 		   break;
! 
! 		case ST_CHAL_SRV:
! 		   if (!strncmp(buf,"OK RESPSRV",10) && cs2cl(buf,reshsrv,VTUN_RESP_HASH_SIZE)) {
! 		      response_to_chal (chalsrv, host, res, resh);
! 		      if (memcmp (resh, reshsrv, VTUN_RESP_HASH_SIZE)) {
! 			 /* Server authentication failed */
! 			 break;
! 		      }
! 
! 		      SHA1_Update (&sesctx, res, VTUN_RESP_SIZE); // srv.rnd
! 		      response_to_chal (chalcli, host, res, resh);
! 		      SHA1_Update (&sesctx, res, VTUN_RESP_SIZE); // cli.rnd
! 		      print_p (fd, "RESPCLI: %s\n", cl2cs (resh, VTUN_RESP_HASH_SIZE));
! 
! 		      SHA1_Final (host->seskey, &sesctx);
! 		      SHA1_Init (&sesctx);  // wipe data
  
+ 		      stage = ST_CHAL_CLI;
  		      continue;
  	   	   }
  		   break;	
  	
! 	        case ST_CHAL_CLI:
! 		   if( !strncmp(buf,"OK",2) && cf2bf(buf,host) ) {
  		      success = 1;
+ 		   }
  		   break;
  	   }
  	   break;
